<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditRestaurantCart"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="14">
            <el-form-item label="用户id" prop="RestaurantCart.userId">
              <el-input
                class="input-item"
                v-model="formData.RestaurantCart.userId"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="餐馆id" prop="RestaurantCart.restaurantId">
              <el-input
                class="input-item"
                v-model="formData.RestaurantCart.restaurantId"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="美食id" prop="RestaurantCart.restaurantFoodId">
              <el-input
                class="input-item"
                v-model="formData.RestaurantCart.restaurantFoodId"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="数量" prop="RestaurantCart.count">
              <el-input-number
                class="input-item"
                v-model="formData.RestaurantCart.count"
                placeholder=""
                :clearable="true"
                :step="1"
                :controls="true"
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSaveClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditRestaurantCart',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { RestaurantCartData } from '@/api/generated/restaurantCartController';
import { RestaurantCartController } from '@/api/generated';
import FormEditRestaurantCart from '@/pages/generated/formEditRestaurantCart.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditRestaurantCart = ref();
// 表单数据定义
type FormEditRestaurantCartData = {
  RestaurantCart: RestaurantCartData;
};
// 表单数据
const formData = reactive<FormEditRestaurantCartData>({
  RestaurantCart: {
    // 主键id
    id: undefined,
    // 用户id
    userId: undefined,
    // 餐馆id
    restaurantId: undefined,
    // 美食id
    restaurantFoodId: undefined,
    // 数量
    count: undefined,
    // 创建者Id
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新者Id
    updateUserId: undefined,
    // 最后更新时间
    updateTime: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    deletedFlag: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'RestaurantCart.restaurantId': [
  ],
  'RestaurantCart.userId': [
    {required: true, message: '请输入用户id', trigger: 'blur'}
  ],
  'RestaurantCart.restaurantFoodId': [
  ],
  'RestaurantCart.count': [
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadRestaurantCartData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.RestaurantCart = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    RestaurantCartController.view(params).then(res => {
      formData.RestaurantCart = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditRestaurantCart = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditRestaurantCart = () => {
  refreshFormEditRestaurantCart();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditRestaurantCart();
};
/**
 * 保存
 */
const onSaveClick = () => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('保存', FormEditRestaurantCart, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
const formInit = () => {
  loadRestaurantCartData().then(res => {
    if (isEdit.value) refreshFormEditRestaurantCart();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
